<template>
    <div class="text-center">
        <v-dialog v-model="dialog" width="500" v-if="isCurrentUserAllowed" ref="dialog">
            <template v-slot:activator="{ on, attrs }">
                <v-btn v-if="!isAdd" v-bind="attrs" v-on="on" icon
                       class="ml-1 mr-1 white--text"
                       @click="setTask">
                    <v-icon color="green">
                        mdi-pencil
                    </v-icon>
                </v-btn>

                <v-btn v-else
                       outlined color="#0ABBEF"
                       elevation="5" class="ml-1 mr-1"
                       v-bind="attrs" v-on="on"
                       @click="addTask">
                    {{ $t("Task.LNG_TASK_ADD") }}
                </v-btn>
            </template>
            <v-card>
                <v-card-title class="headline blue">
                    <span class="headline white--text">
                        {{ (isAdd) ? $t('Task.LNG_TASK_ADD') : $t('Task.LNG_TASK_EDIT') }}
                    </span>
                    <v-spacer></v-spacer>
                    <v-btn color="error" fab small @click="cancel">
                        <v-icon color="white">mdi-close</v-icon>
                    </v-btn>
                </v-card-title>
                <v-card-text>
                    <v-form ref="form" class="px-3">
                        <v-row no-gutters class="mt-3">
                            <v-col cols="12">
                                <v-text-field
                                    v-model="title"
                                    :label="$t('Task.LNG_TASK_TITLE')"
                                    :rules="[v => !!v || $t('Task.LNG_TASK_MANDATORY')]"
                                    required
                                    color="#0BBBEF"
                                    clearable
                                />
                            </v-col>
                            <v-col cols="12">
                                <v-textarea
                                    v-model="description"
                                    :label="$t('Task.LNG_TASK_DESCRIPTION')"
                                    required
                                    color="#0BBBEF"
                                    clearable
                                    counter
                                    :rules="[v => !!v || $t('Task.LNG_TASK_MANDATORY'), (v => v && v.length <= 255) || 'Max 255 characters']"
                                />
                            </v-col>
                            <v-col cols="12">
                                <v-switch
                                    v-model="containsWork"
                                    :label="$t('Task.LNG_TASK_CONTAINSWORK')"
                                ></v-switch>
                            </v-col>
                            <v-col cols="12">
                                <v-row no-gutters>
                                    <v-col cols="12" v-if="isBegAfterEnd">
                                        <p style="color: #ff0000">{{ $t('LNG_LESSON_BEGAFTEREND') }}</p>
                                    </v-col>
                                    <v-col cols="12" v-else-if="!datesFilled">
                                        <p style="color: #ff0000">{{ $t('LNG_LESSON_WORKFORMINCORRECT') }}</p>
                                    </v-col>
                                    <v-col cols="12" md="6">
                                        <v-menu
                                            v-model="menuDateStart"
                                            :close-on-content-click="false"
                                            :nudge-right="-20"
                                            :nudge-top="-30"
                                            transition="scale-transition"
                                            offset-y
                                            top
                                            min-width="250px"
                                        >
                                            <template v-slot:activator="{ on, attrs }">
                                                <v-text-field class="mr-4"
                                                              v-model="dateStart"
                                                              :label="$t('LNG_LESSON_DATESTART')"
                                                              prepend-icon="mdi-calendar"
                                                              v-bind="attrs"
                                                              v-on="on"
                                                              @change="updateBeginning"
                                                ></v-text-field>
                                            </template>
                                            <v-date-picker
                                                v-model="dateStart"
                                                @input="menuDateStart = false"
                                                @change="updateBeginning"
                                            ></v-date-picker>
                                        </v-menu>
                                        <v-menu
                                            v-model="menuTimeStart"
                                            :close-on-content-click="false"
                                            :nudge-right="-20"
                                            :nudge-top="-30"
                                            transition="scale-transition"
                                            offset-y
                                            top
                                            min-width="290px"
                                        >
                                            <template v-slot:activator="{ on, attrs }">
                                                <v-text-field class="mr-4"
                                                              v-model="timeStart"
                                                              :label="$t('LNG_LESSON_TIMESTART')"
                                                              prepend-icon="mdi-clock-time-four-outline"
                                                              v-bind="attrs"
                                                              v-on="on"
                                                              @change="updateBeginning"
                                                ></v-text-field>
                                            </template>
                                            <v-time-picker
                                                format="24hr"
                                                srollable
                                                v-if="menuTimeStart"
                                                v-model="timeStart"
                                                @input="menuTimeStart = false"
                                                @change="updateBeginning"
                                                full-width
                                            ></v-time-picker>
                                        </v-menu>
                                    </v-col>
                                    <v-col cols="12" md="6">
                                        <v-menu
                                            v-model="menuDateEnd"
                                            :close-on-content-click="false"
                                            :nudge-right="-20"
                                            :nudge-top="-30"
                                            transition="scale-transition"
                                            offset-y
                                            top
                                            min-width="250px"
                                        >
                                            <template v-slot:activator="{ on, attrs }">
                                                <v-text-field class="mr-4"
                                                              v-model="dateEnd"
                                                              :label="$t('LNG_LESSON_DATEEND')"
                                                              prepend-icon="mdi-calendar"
                                                              v-bind="attrs"
                                                              v-on="on"
                                                              @change="updateEnding"
                                                ></v-text-field>
                                            </template>
                                            <v-date-picker
                                                v-model="dateEnd"
                                                @input="[menuDateEnd = false]"
                                                @change="updateEnding"/>
                                        </v-menu>
                                        <v-menu
                                            v-model="menuTimeEnd"
                                            :close-on-content-click="false"
                                            :nudge-right="-20"
                                            :nudge-top="-30"
                                            transition="scale-transition"
                                            offset-y
                                            top
                                            min-width="290px"
                                        >
                                            <template v-slot:activator="{ on, attrs }">
                                                <v-text-field class="mr-4"
                                                              v-model="timeEnd"
                                                              :label="$t('LNG_LESSON_TIMEEND')"
                                                              prepend-icon="mdi-clock-time-four-outline"
                                                              v-bind="attrs"
                                                              v-on="on"
                                                              @change="updateEnding"
                                                ></v-text-field>
                                            </template>
                                            <v-time-picker
                                                format="24hr"
                                                srollable
                                                v-if="menuTimeEnd"
                                                v-model="timeEnd"
                                                @input="menuTimeEnd = false"
                                                @change="updateEnding"
                                                full-width/>
                                        </v-menu>
                                    </v-col>
                                </v-row>
                            </v-col>
                            <v-col cols="12" class="text-center mt-4">
                                <v-btn color="error" class="mr-4" @click="cancel">
                                    {{ $t('LNG_LESSON_CANCEL') }}
                                </v-btn>
                                <v-btn :disabled="!valid" color="success" class="mr-4" @click="submit">
                                    {{ $t('LNG_LESSON_VALIDATE') }}
                                </v-btn>
                            </v-col>
                            <v-col cols="12" class="text-center mt-2">
                                <p v-if="requestOK || requestFail"
                                   :style="{ color: (requestOK) ? '#0ABBEF' : '#ff0000'}"
                                   class="mb-n2">
                                    {{ message }}
                                </p>
                            </v-col>
                        </v-row>
                    </v-form>
                </v-card-text>
            </v-card>
        </v-dialog>
    </div>
</template>

<script>
import Services from "@/services/api/index"
import dayjs from 'dayjs';
import { mapGetters } from "vuex";

export default {
    name: 'TaskEdit',
    props: {
        isAdd: {
            type: Boolean,
            default: false
        },
        task: {
            type: Object,
            required: false
        }
    },
    data: () => ({
        dialog: false,
        valid: true,
        title: "",
        description: "",
        containsWork: false,
        menuDateStart: false,
        menuDateEnd: false,
        menuTimeStart: false,
        menuTimeEnd: false,
        dateStart: null,
        dateEnd: null,
        timeStart: null,
        timeEnd: null,
        beginning: null,
        ending: null,
        datesFilled: true,
        isBegAfterEnd: false,
        requestOK: false,
        requestFail: false,
        message: ""
    }),
    computed: {
        ...mapGetters([
            'user',
            'lessons',
            'currentLessonId'
        ]),
        isCurrentUserAllowed() {
            return this.user && (this.user.type === 'TEACHER' || this.user.type === 'ADMIN');
        },
        realCurrentLessonId() {
            return this.lessons[this.currentLessonId].id;
        }
    },
    watch: {
        dialog: function (dialog) {
            if (!dialog) {
                this.cancel();
            }
        },
    },
    methods: {
        addTask() {
            this.beginning = dayjs();
            this.dateStart = this.beginning.format("YYYY-MM-DD");
            this.timeStart = this.beginning.format("HH:mm");
        },
        // Fill in the form fields when the user clicks on the edit button
        setTask() {
            this.title = this.task.title;
            this.description = this.task.description;
            this.containsWork = this.task.contains_work;
            this.beginning = this.task.beginning;
            this.ending = this.task.ending;

            const start = (this.beginning === null) ? null : dayjs(new Date(this.beginning));
            const end = (this.ending === null) ? null : dayjs(new Date(this.ending));

            if (start) {
                this.dateStart = start.format("YYYY-MM-DD");
                this.timeStart = start.format("HH:mm");
            }
            if (end) {
                this.dateEnd = end.format("YYYY-MM-DD");
                this.timeEnd = end.format("HH:mm");
            }
            this.datesFilled = true;
        },
        // Each times the beginning or ending dates are modified (day with hours) -> check if the chosen dates are valid
        updateBeginning() {
            if (this.dateStart && this.timeStart) {
                this.beginning = dayjs(this.dateStart + '/' + this.timeStart, 'YYYY-MM-DD/HH:mm');
                if (this.ending !== null) {
                    this.isBegAfterEnd = this.beginning > this.ending;
                }
            }
            this.datesFilled = !((this.dateStart && !this.timeStart) || (!this.dateStart && this.timeStart) ||
                (this.dateEnd && !this.timeEnd) || (!this.dateEnd && this.timeEnd));
        },
        updateEnding() {
            if (this.dateEnd && this.timeEnd) {
                this.ending = dayjs(this.dateEnd + '/' + this.timeEnd, 'YYYY-MM-DD/HH:mm');
                if (this.beginning !== null) {
                    this.isBegAfterEnd = this.beginning > this.ending;
                }
            }
            this.datesFilled = !((this.dateStart && !this.timeStart) || (!this.dateStart && this.timeStart) ||
                (this.dateEnd && !this.timeEnd) || (!this.dateEnd && this.timeEnd));
        },
        submit() {
            if (this.$refs.form.validate()) {
                // If form isn't well completed -> do nothing
                if (!this.datesFilled || this.isBegAfterEnd) {
                    return;
                }
                let data = {
                    title: this.title,
                    description: this.description,
                    contains_work: this.containsWork,
                    beginning: this.beginning?.valueOf(),
                    ending: this.ending?.valueOf(),

                }

                if (this.isAdd) {
                    data.id_lesson = this.realCurrentLessonId;
                    Services.Task.addTask(data).then((res) => {
                        this.manageHTTPCodeReturned(res.status);
                    })
                } else {
                    data.id = this.task.id;
                    Services.Task.updateTask(data).then((res) => {
                        this.manageHTTPCodeReturned(res.status);
                    })
                }
            }
        },
        // Display a message for the user with the returned HTTP code
        manageHTTPCodeReturned(code) {
            this.requestOK = false;
            this.requestFail = false;
            switch (code) {
                case 200:
                    this.requestOK = true;
                    this.message = this.$t("Task.LNG_TASK_UPDATED");
                    this.$emit("updated");
                    setTimeout(() => {
                        this.cancel();
                    }, 1000);
                    break;
                case 201:
                    this.requestOK = true;
                    this.message = this.$t("Task.LNG_TASK_ADDED");
                    this.$emit("updated");
                    setTimeout(() => {
                        this.cancel();
                    }, 1000);
                    break;
                case 400:
                    this.requestFail = true;
                    this.message = this.$t("LNG_LESSON_ERROR400") + " Code : " + code;
                    break;
                case 404:
                    this.$router.push('404 Not found');
                    break;
                default:
                    if (code >= 400 && code < 500) {
                        this.requestFail = true;
                        this.message = this.$t("LNG_LESSON_CLIENTERROR") + " Code : " + code;
                    } else if (code >= 500 && code < 600) {
                        this.requestFail = true;
                        this.message = this.$t("LNG_LESSON_SERVERERROR") + " Code : " + code;
                    } else {
                        this.requestFail = true;
                        this.message = this.$t("LNG_LESSON_FAILED") + " Code : " + code;
                    }
            }
        },
        cancel() {
            this.$refs.form.reset();
            this.requestOK = false;
            this.requestFail = false;
            this.dialog = false;
        }
    }
}

</script>